#include <unordered_set>
#include <utility>
#include <vector>
#include "./RoadNetwork.h"
#include "./Dijkstra.h"
class TransferPatterns: public SimpleDijkstra
{
  public:
  TransferPatterns(TransitNetworkExpanded* roadNetwork,
                   DistanceHeuristic* heuristic);
  // returns false once endid was found...
  //bool nodeAllowed(int nodeId);

  void doPrecomputation();
  void resetNode(int nodeId);
  // find shortest path...
  void computeShortestPath(int startId);
  // the shortest path: last Edge is a dummy edge...
  vector< vector<int> >* transferPatterns;
 private:
  // reconstruct shortest path..
  void reconstructShortestPath(int startId);
  TransitNetworkExpanded* _tranGraph;
  bool _endStopFound;
  int _endStopId;
  int _endId;
};