// Copyright November 30, 2011 Robin Schirrmeister and Simon Skilevic
// Chair of Algorithms and Datastructures Uni Freiburg
#include <assert.h>


#include "./LiveConnection.h"

LiveConnection::LiveConnection(const Connection& connection,
                 NetworkType destinationType,
                 int destinationNodeId,
                 size_t time,  size_t transfers, bool tripBeforeEnded)
{
  assert(time >= 0);
  this->connection = connection;
  this->destinationType = destinationType;
  this->toNodeId = destinationNodeId;
  this->time = time;
  this->transfers = transfers;
  this->tripBeforeEnded = tripBeforeEnded;
}
